(function ($) {
    /**
     * Initialize the uc_location module code: add the "apply_address()"
     **/
    Drupal.behaviors.ucLocationInitialize = {
      attach: function(elt) {
        // 'elt' will be the document the first time this gets called; may be anything at any other time
        if (! Drupal.settings.ucLocation) {
          Drupal.settings.ucLocation = {};
        }
        if (! Drupal.settings.ucLocation.initialized) {
          $('#edit-panes-delivery-delivery-address-select,#edit-panes-billing-billing-address-select').change( 
            function (evt) {
              if (evt.target.id == 'edit-panes-delivery-delivery-address-select') {
                uc_location_apply_address("delivery", evt.target.value);
              } 
              else if (evt.target.id == 'edit-panes-billing-billing-address-select') {
                uc_location_apply_address("billing", evt.target.value);
              }
            });
          
          Drupal.settings.ucLocation.initialized = true;
        }
      }
    };
    
    


    function uc_location_apply_address(type, address_str) {
      if (address_str == "0") {
        return;
      }

      console.log("address_str is: " + address_str);
      
      eval("var address = " + address_str + ";"); // ????
      
      var pane = "edit-panes-" + type + "-" + type;
      $("#" + pane + "-first-name").val(address.first_name);
      $("#" + pane + "-last-name").val(address.last_name);
      $("#" + pane + "-company").val(address.company);
      $("#" + pane + "-phone").val(address.phone);
      $("#" + pane + "-street1").val(address.street1);
      $("#" + pane + "-street2").val(address.street2);
      $("#" + pane + "-city").val(address.city);
      $("#" + pane + "-postal-code").val(address.postal_code);
      
      var country = $("#" + pane + "-country");
      if(country.val() != address.country) {
        country.val(address.country);
        country.trigger("change");
        // Need to wait for the ajax call on country change to complete.
        // If it takes longer than a second, the user will have to select the zone themself.
        setTimeout(uc_location_set_zone, 1050);
        
        // $("#" + pane + "-zone").val(address.zone).trigger("change");
        //uc_update_zone_select(pane + "-country", address.zone);
      }
      else {
        $("#" + pane + "-zone").val(address.zone);
      }
      
    function uc_location_set_zone() {
        // Everytime a different country is slected, the zone selection is replaced with a 
        // new selection field. sp allow for a few changes.
         $("#" + pane + "-zone--2").val(address.zone);
         $("#" + pane + "-zone--3").val(address.zone);
         $("#" + pane + "-zone--4").val(address.zone);
         $("#" + pane + "-zone--5").val(address.zone);
         $("#" + pane + "-zone--6").val(address.zone);
    }
      
    }
})(jQuery);